
/*------------------------------------------------------------------------------

  Copyright (c) 2018-2022 boshra rajaei (bo.rajaei@gmail.com)

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>.

  partition.h - This file belongs to ELSDc+ project (Ellipse and Line Segment
           Detector with continuous validation).
         - It defines constants, data types, prototypes for partitioning functions
           needed in different parts of the project.

------------------------------------------------------------------------------*/
#ifndef PARTITION_H
#define PARTITION_H

/*----------------------------------------------------------------------------*/
/** Data structure for linked list of chain partitions.
 */
typedef struct parti parList;
struct parti
{
  int length;
  int *cut_pnt;
  int *prim_type;
  parList *next;
};

/*----------------------------------------------------------------------------*/
/** Data structure for dots used to show chain in svg output file.
 */
typedef struct
{
  double rad;              /* dot radius */
  double cx, cy;           /* center of the dot indicating cutting point in chain */
  double width;            /* dot border width */
} Dot ;

void generate_partition(parList *par, int *parcnt, PolyRect poly, int max_cnt_pnt); //, double prec
void clear_partition( parList *par );

#endif
