/*------------------------------------------------------------------------------

  Copyright (c) 2018-2022 boshra rajaei (bo.rajaei@gmail.com)

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>.

  temp_storage.h - This file belongs to ELSDc+ project (Ellipse and Line Segment
           Detector with continuous validation).
         - It defines data structure requires to temporary save the information about current
           partition for later improvement.

------------------------------------------------------------------------------*/
#ifndef TEST_STORAGE_H
#define TEST_STORAGE_H



/*----------------------------------------------------------------------------*/
/** Data structure for temporary keeping the necessary information about current partition that we later
    require in improving the width.
 */
typedef struct
{
  PolyRect *seg;
  Ring *ering;
  double foci[4];
  int x;
  int y;
  int grad_dire;
} tmp_storage;


#endif
